package cn.estsh.i3plus.core.apiservice.controller.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ISysLogExceptionService;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.platform.bean.SysLogException;
import cn.estsh.impp.framework.base.controller.CoreBaseController;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description : 系统异常日志服务
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2018-11-19 18:42
 * @Modify:
 **/
@RestController
@Api(description = "系统异常日志服务")
@RequestMapping(CoreBaseController.BASE_URL + "/sys-log-exception")
public class SysLogExceptionController {
    public static final Logger LOGGER = LoggerFactory.getLogger(SysLogExceptionController.class);

    @Autowired
    private ISysLogExceptionService sysLogExceptionService;

        @GetMapping(value = "/query")
        @ApiOperation(value = "异常日志复杂查询，分页，排序",notes = "异常日志复杂查询，分页，排序")
        public ResultBean querySysLogOperateByPager(SysLogException sysLogException, Pager pager){
            try {
                ListPager logExceptionList = sysLogExceptionService.querySysLogExceptionByPager(sysLogException, pager);
                return ResultBean.success("查询成功").setListPager(logExceptionList).setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
            }catch(ImppBusiException busExcep){
                return ResultBean.fail(busExcep);
            }catch(Exception e){
                return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
            }
    }
}
